#include "testlib.h"

#include <set>
#include <vector>
#include <algorithm>

void dfs(const std::vector<std::vector<int>> &graph,
         std::vector<bool> &used, int v) {
  used[v] = true;
  for (int u : graph[v]) {
    if (!used[u]) {
      dfs(graph, used, u);
    }
  }
}

int main() {
    registerValidation();
    
    int n = inf.readInt(2, 10);
    inf.readSpace();
    int m = inf.readInt(1, 45);
    inf.readEoln();
    std::set<std::pair<int, int>> edges;
    std::vector<std::vector<int>> graph(n);
    for (int i = 0; i < m; i++) {
      int v = inf.readInt(1, n);
      inf.readSpace();
      int u = inf.readInt(1, n);
      inf.readEoln();
      ensure(v != u && edges.find(std::make_pair(v, u)) == edges.end());
      edges.insert(std::make_pair(v, u));
      edges.insert(std::make_pair(u, v));
      graph[v - 1].push_back(u - 1);
      graph[u - 1].push_back(v - 1);
    }
    std::vector<bool> used(n, false);
    dfs(graph, used, 0);
    for (int i = 0; i < n; i++) {
      ensure(used[i]);
    }

    inf.readEof();

    return 0;
}