#!/bin/bash

problem=qual
lang=$2
if [ "$lang" == "cpp" ]; then
  g++ ${problem}_${1}.cpp -std=c++11 -o ${problem}_${1}.exe
  ulimit -s 65536
  solution="./${problem}_${1}.exe"
fi

if [ "$lang" == "py" ]; then
  solution="./${problem}_${1}.py"
fi


for i in preliminary tests/subtask1 tests/subtask2 tests/subtask3 tests/subtask4
do
  for j in $i/*
  do
    if [ -f ${j}.a ]; then
	  echo -n test $j " "
      cp $j ${problem}.in > /dev/null

      echo -n "running "
      $solution
      if [ $? -ne 0 ]; then
        echo -n FAIL
		# break
      fi

      echo -n "checking "
      diff ${problem}.out ${j}.a > /dev/null
      if [ $? -ne 0 ]; then
		echo -n WA
		# break
      fi
      echo
	  # echo OK
    fi
  done
  echo
done

rm *.exe *.in *.out

